%% effekt tatt fra nettet for use case "Regulering av effekt trukket fra nettet"
%Netto effekt tatt fra nettet = P_g =(P_L-P_pv+P_B-P_lim)

%Fr denne koden kjres enten usecase_effektgrense_12.m eller 
%usecase_effektgrense_075.m

%P_lim er enten 0.75 eller 1.2
P_lim=1.2;

%Finner tidene der batteriet lades ut - alts dekker forbruk
samlet_utlading_batteri=zeros(4391,1);
for i=1:4391
    if samlet_bat(i,1)<0 %opp- og utlading av batteri for april-september
        samlet_utlading_batteri(i,1)=samlet_bat(i,1);
    end
end

%Regner ut diff mellom last - produksjon - utlading av batteri - plim
diff1=zeros(4391,1);
for i=1:4391
   diff1(i,1)=samlet_last(i,1)- samlet_pvprod(i,1)- P_lim + samlet_utlading_batteri(i,1);
end
%samlet_last er en vektor med lastprofilen for april-september
%samlet_pvprod er en vektor med produksjonen for april-september

%Finner stedene der P_g er positiv - det betyr at effekt er tatt fra nettet
%over plim etter at batteriet har kompensert 
P_g1=zeros(4391,1);
for i=1:4391
    if diff1(i,1)>0
        P_g1(i,1)=diff1(i,1);
    end
end

%uten kompensering av batteri
%Regner ut diff mellom last - produksjon - plim
diff=zeros(4391,1);
for i=1:4391
   diff(i,1)=samlet_last(i,1)-samlet_pvprod(i,1)-P_lim;
end
%Finner stedene der P_g er positiv - det betyr at effekt er tatt fra nettet
P_g=zeros(4391,1);
for i=1:4391
    if diff(i,1)>0
        P_g(i,1)=diff(i,1);
    end
end

%% Effekt utvekslet med nettet - sum for hver mned
effekt_uten=zeros(6,1);%uten bruk av batteri
effekt_med=zeros(6,1);%med bruk av batteri
%uten batteri
for i=1:6
    if i==1 %april
        effekt_uten(i,1)=sum(P_g(1:720,1));
    elseif i==2 %mai
        effekt_uten(i,1)=sum(P_g(721:1464,1));
    elseif i==3 %juni
        effekt_uten(i,1)=sum(P_g(1465:2184,1));
    elseif i==4 %juli
        effekt_uten(i,1)=sum(P_g(2185:2928,1));
    elseif i==5 %august
        effekt_uten(i,1)=sum(P_g(2929:3672,1));
    else %september
        effekt_uten(i,1)=sum(P_g(3673:4391,1));
    end
end

%med batteri
for i=1:6
    if i==1 %april
        effekt_med(i,1)=sum(P_g1(1:720,1));
    elseif i==2 %mai
        effekt_med(i,1)=sum(P_g1(721:1464,1));
    elseif i==3 %juni
        effekt_med(i,1)=sum(P_g1(1465:2184,1));
    elseif i==4 %juli
        effekt_med(i,1)=sum(P_g1(2185:2928,1));
    elseif i==5 %august
        effekt_med(i,1)=sum(P_g1(2929:3672,1));
    else %september
        effekt_med(i,1)=sum(P_g1(3673:4391,1));
    end
end

%transpose
effekt_med=effekt_med.';%effekt tatt fra nettet med batteri
effekt_uten=effekt_uten.';%effekt tatt fra nettet uten batteri

%% plot
figure
time=(1:4391).';
subplot(2,1,1);
plot(time, P_g1)
xlabel('Time (h)')
ylabel('kWh')
legend('Effekt tatt fra nettet, med batteri')
xlim([0 4391])
ylim([1.2 3])
title('Effektgrense = 1.2 kW')
subplot(2,1,2);
plot(time, P_g)
xlim([0 4391])
ylim([1.2 5])
xlabel('Time (h)')
ylabel('kWh')
legend('Effekt tatt fra nettet, uten batteri')
%print(['C:\Users\Siri\Downloads\Desktop\Dropbox\Apps\ShareLaTeX\Master\images\effekttattfranettet12'],'-depsc')