%Egenforbruket for use case "Hndtering av plusskundens PV produksjon"
%regnes ut.
%M laste ned mlingene med matlabskriptet usecase_egenforbruk_load og
%samle mlingene for april-august og september.
%De positive verdiene til batteriet blir funnet = opplading av batteri
%Mlingene for produksjon, forbruk og opplading av batteri blir interpolert
%Forenklingen gjres - om batteriet aldri er strre enn null vil det tilsi
%at forbruket alltid er hyere enn produksjonen, og som en forenkling
%settes da egenforbruket til 0 for den dagen.
%Forbruket dekket av produksjon blir funnet, nr utsagnet over er usant.
%Egenforbruket regnes ut

%%
prod=samlet_pvprod;
forb=samlet_last;
batt=samlet_bat;

%strrelsen til mlingene - row variabelen gir strrelse
[rowp,colp]=size(prod); 
[rowf,colf]=size(forb);
[rowb,colb]=size(batt);

%finner positive batteri verdier 
batt_over=zeros(rowb,1);
for i=1:rowb
    if batt(i,1)>0
        batt_over(i,1)=batt(i,1);
    end
end

X = 1:24;%intepolerer produksjon, forbruk og batteri over 0
x_given=1:0.0001:24; %x verdier som det skal interpoleres for 
[jx,ix]=size(x_given);%strrelsen til x intervallet
areal=zeros(3,rowp/24);%har en rad for - rad 1:bat - rad2:prod - rad3:dekket forbruk. kolonner:dager
egenforbruk=zeros(2,rowp/24); %rad1: med batteri - rad2:uten batteri. kolonner: dager
ind=zeros(24,1);
for it=1:(rowp/24)
    Yp = prod(((it-1)*24)+1:it*24); 
    yp_given=interp1(X,Yp,x_given,'linear');%produksjon
    Yf=forb(((it-1)*24)+1:it*24);
	yf_given=interp1(X,Yf,x_given,'linear');%forbruk
    Yb = batt_over(((it-1)*24)+1:it*24);
    yb_given=interp1(X,Yb,x_given,'linear');%batteri
    
    if Yb<=0 %nr forbruket alltid er hyere enn produksjon, vil heller ikke batteriet lades opp
             %og det ikke er noe skjringspunkt - antar da at all
             %produksjon gr til  dekke forbruket, og finner tidene der pv
             %produksjon er over null og finner forbruket for de samme
             %tidene
         for t=1:24
            if Yp(t,1)>0
                ind(t,1)=1;
            else
                ind(t,i)=0;
            end
            V1 = find(ind, 1, 'first');%frste punktet produksjonen er over null
            V2 = find(ind, 1, 'last');%siste punktet produksjonen er over null
         end
        areal(2,it) = trapz(Yp);%areal av prod
        areal(1,it) =0;%areal av batteri
        areal(3,it)=trapz(Yf(V1:V2,1));%areal av dekket forbruk
        egenforbruk(1,it)=areal(2,it)/areal(3,it);%med batteri
        egenforbruk(2,it)=egenforbruk(1,it);%uten batteri
    else
    %transpose
    yf_given=yf_given.';
    yp_given=yp_given.';

    yp_given=round(yp_given, 3);
    yf_given=round(yf_given, 3);

    n=ix;
    idx=find(yp_given == yf_given,n,'first'); %finner skjringspunkt
    idx(end)
    [row, col]=size(idx);
    
    %finner forbruket dekket av produksjonen mellom skjringspunktene - legger
    %det sammen til en vektor 
    dekket_forbruk = yp_given(1:idx(1,1),1);%produksjon til frste skjringspunkt
    del_for= yf_given(idx(2,1):idx(end-1,1),1);%forbruk mellom skjringspunkt
    siste_for= yp_given(idx(end,1):ix,1);%produksjon etter andre skjringspunkt

        for i=1:length(del_for)
            dekket_forbruk(end+1)=(del_for(i,1));
        end

        for i=1:length(siste_for)
        dekket_forbruk(end+1)=siste_for(i,1);
        end

    %finner arealene og legger de til i areal matrisen
    diff_tb=yb_given;
    areal(1,it) = trapz(diff_tb);%areal av batteri
    diff_tp=yp_given.';
    areal(2,it) = trapz(diff_tp);%areal av prod
    diff_tf=dekket_forbruk.';
    areal(3,it) = trapz(diff_tf);%areal av dekket forbruk
    
    egenforbruk(1,it)=((areal(3,it)*0.0001)+(areal(1,it)*0.0001))/(areal(2,it)*0.0001);%med batteri
    egenforbruk(2,it)=(areal(3,it)*0.0001)/(areal(2,it)*0.0001);%uten batteri
    
    end
end
